org.apache.lucene.search

## Class FuzzyLikeThisQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.search.FuzzyLikeThisQuery

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable

      public class FuzzyLikeThisQuery
      extends Query

  Fuzzifies ALL terms provided as strings and then picks the best n differentiating terms. In effect this mixes the behaviour of FuzzyQuery and MoreLikeThis but with special consideration of fuzzy scoring factors. This generally produces good results for queries where users may provide details in a number of fields and have no knowledge of boolean query syntax and also want a degree of fuzzy matching and a fast query. For each source term the fuzzy variants are held in a BooleanQuery with no coord factor (because we are not looking for matches on multiple variants in any one doc). Additionally, a specialized TermQuery is used for variants and does not use that variant term's IDF because this would favour rarer terms eg misspellings. Instead, all variants use the same IDF ranking (the one for the source query term) and this is factored into the variant's boost. If the source query term does not exist in the index the average IDF of the variants is used.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FuzzyLikeThisQuery(int maxNumTerms, Analyzer analyzer)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addTerms(java.lang.String queryString, java.lang.String fieldName, float minSimilarity, int prefixLength)` Adds user input for "fuzzification"
    `boolean` | `equals(java.lang.Object obj)`
    `int` | `hashCode()`
    `boolean` | `isIgnoreTF()`
    `Query` | `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
    `void` | `setIgnoreTF(boolean ignoreTF)`
    `java.lang.String` | `toString(java.lang.String field)` Prints a query to a string, with `field` assumed to be the default field and omitted.

    - ### Methods inherited from class org.apache.lucene.search.Query

      `clone, combine, createWeight, extractTerms, getBoost, getSimilarity, mergeBooleanQueries, setBoost, toString, weight`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FuzzyLikeThisQuery

          public FuzzyLikeThisQuery(int maxNumTerms,
                                    Analyzer analyzer)

      Parameters:
        `maxNumTerms` - The total number of terms clauses that will appear once rewritten as a BooleanQuery
        `analyzer` -

  - ### Method Detail

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Query`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `Query`

    - #### addTerms

          public void addTerms(java.lang.String queryString,
                               java.lang.String fieldName,
                               float minSimilarity,
                               int prefixLength)

      Adds user input for "fuzzification"
      Parameters:
        `queryString` - The string which will be parsed by the analyzer and for which fuzzy variants will be parsed
        `fieldName` -
        `minSimilarity` - The minimum similarity of the term variants (see FuzzyTermEnum)
        `prefixLength` - Length of required common prefix on variant terms (see FuzzyTermEnum)

    - #### rewrite

          public Query rewrite(IndexReader reader)
                        throws java.io.IOException

      Description copied from class: `Query`
      Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.
      Overrides:
        `rewrite` in class `Query`
      Throws:
        `java.io.IOException`

    - #### toString

          public java.lang.String toString(java.lang.String field)

      Description copied from class: `Query`
      Prints a query to a string, with `field` assumed to be the default field and omitted.

      The representation used is one that is supposed to be readable by `QueryParser`. However, there are the following limitations:

      - If the query was created by the parser, the printed representation may not be exactly what was parsed. For example, characters that need to be escaped will be represented without the required backslash.
      - Some of the more complicated queries (e.g. span queries) don't have a representation that can be parsed by QueryParser.
      Specified by:
        `toString` in class `Query`

    - #### isIgnoreTF

          public boolean isIgnoreTF()

    - #### setIgnoreTF

          public void setIgnoreTF(boolean ignoreTF)

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.